# Урок

:project Programming

## Условия

:overlay

:position 30,30,40,40

:navigate projects.code.console

### Условия

Условия или *условные выражения* это возможность для программы принимать решения.
Речь идет о проверке гипотезы и выполнении различных операций в зависимости от того, является ли результат истинным или ложным.


## Лексика

:navigate projects.code.console

:position 55,30,40,40

### Лексика

Условные выражения строятся с помощью ключевых слов ``if``, ``then``, ``else``, ``end``.


## Простое условие

:navigate projects.code.console

:position 55,30,40,40

### Простое условие

Определим следующую функцию:

```
test = function(number)
  if number < 0 then
    print( "число отрицательное" )
  end
end
```

Эта функция принимает число в качестве аргумента. Она проверяет, если *if* число меньше нуля. Если это так, тогда *then* выполняется команда ``print("число отрицательное")``.
Первое "end" закрывает условие "if". Второе "end" закрывает определение нашей функции.

## Простое условие

:navigate projects.code.console

:position 55,30,40,40

### Простое условие

Давайте протестируем нашу функцию! Попробуйте, например:

```
test(10)
test(-5)
test(0)
test(-100)
```

## Простое условие

:navigate projects.code.console

:position 55,30,40,40

### Что означает "else"?

Ключевое слово ``else`` позволяет вам выполнить последовательность операций, когда условие проверяемое оператором "if", является ложным. Например:

```
test = function(number)
  if number < 0 then
    print( "число отрицательное" )
  else
    print( "число положительное" )
  end
end
```

## Простое условие

:navigate projects.code.console

:position 55,30,40,40

### Положительное или отрицательное?

Давайте еще раз проверим некоторые значения:

```
test(1)
test(-15)
```

## Простое условие

:navigate projects.code.console

:position 55,30,40,40

### Есть ли еще варианты?

В *microScript* предлагается последнее ключевое слово ``elsif``, которое является сокращением *else* и *if*. Оно буквально означает "иначе если" и поэтому позволяет провести серию тестов и изолировать более двух различных возможностей. Например:

```
test = function(number)
  if number < 0 then
    print( "число отрицательное" )
  elsif number == 0 then
    print( "число равно нулю")
  else
    print( "число положительное" )
  end
end
```

## Простое условие

:navigate projects.code.console

:position 55,30,40,40

### Дополнительные возможности

Теперь наш код способен различать 3 случая: отрицательное число, ноль или ни одно из них, т.е. число строго больше нуля (строго положительное). Давайте проверим это!

```
test(0)
test(-15)
test(12)
```

## Простое условие

:navigate projects.code.console

:position 55,30,40,40

### Проверьте свой код!

Когда вы пишете условное выражение, будьте внимательны, чтобы не забыть ключевое слово ``then`` после каждого ``if`` и каждого ``elsif``.

Также не забудьте *закрыть* условное выражение с помощью ``end``. Каждый оператор ``if`` должен иметь ровно один соответствующий ``end``.
